| Home | Libraries | People | FAQ | More

##### url_view_base::userinfo

Return the userinfo.

###### Synopsis

    template<
        class StringToken = string_token::return_string>
    StringToken::result_type
    userinfo(
        StringToken&& token = {}) const;

###### Description

If present, this function returns a string representing the userinfo (which may be empty). Otherwise it returns an empty string. Any percent-escapes in the string are decoded first.

###### Remarks

This function uses the string token return type customization. Depending on the token passed, the return type and behavior of the function can be different. See `string_token::return_string` for more information.

###### Example

    assert( url_view( "http://jane%2Ddoe:pass@example.com" ).userinfo() == "jane-doe:pass" );

###### Complexity

Linear in `this->userinfo().size()`.

###### Exception Safety

Calls to allocate may throw.

###### Return Value

When called with no arguments, a value of type `std::string` is returned. Otherwise, the return type and meaning depends on the string token passed to the function.

###### BNF

    userinfo    = user [ ":" [ password ] ]

    authority   = [ userinfo "@" ] host [ ":" port ]

###### Specification

- 3.2.1. User Information (rfc3986)

###### See Also

`has_password`, `has_userinfo`, `encoded_password`, `encoded_user`, `encoded_userinfo`, `password`, `user`.